#include <bits/stdc++.h>
using namespace std;

int cifre(int n) {
    int br = 0;
    while (n > 0) {
        n >>= 1;
        br++;
    }
    return br;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);
    int n, q;
    cin >> n >> q;
    int a[n + 10][40] = {0};
    int x;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < 40; j++) {
            a[i][j] = a[i - 1][j];
        }
        cin >> x;
        a[i][cifre(x)]++;
    }
    int l, r;
    while (q--) {
        cin >> l >> r;
        int s = 0;
        for (int j = 0; j < 40; j++)
            s = max(s, a[r][j] - a[l - 1][j]);
        cout << s << '\n';
    }
    return 0;
}